%Fix seed for reproducibility
rng(1)

chain_length=10^5;
%chain_length=2*10^5;

Post_mean_store=NaN(2,sims);
Post_sd_store=NaN(2,sims);
GMM_store=NaN(2,sims);
accept_store=NaN(sims,1);
obs=length(y);

parfor m=1:sims
    rng(m)
    
    sample=randsample(obs,sim_obs,true,weights);
    mixind=binornd(1,mixprob,sim_obs,1);
    mixrand=(randi(2,sim_obs,1)-1.5)*2;
    
    data_sim=data(sample,:);
    y_sim=data_sim(:,1);
    y_sim=y_sim+randn(length(y_sim),1)*sigma_y;
    d_sim=data_sim(:,2);
    x_sim=data_sim(:,3);
    z_sim=data_sim(:,4:end);
    z_sim(mixind==0,:)=z_sim(mixind==0,:).*repmat(mixrand(mixind==0,:),1,size(z_sim,2));
    
    theta_init=True_params';

    moment_dim=size(x,2)+size(z,2);
    
    %create check function
    rho=@(tau_temp,u) tau_temp-(u<=0);
    
    %create moment function
    gmat=@(tau_temp,beta,alpha) repmat(rho(tau_temp,y_sim-d_sim*beta-x_sim*alpha),1,size(x,2)+size(z,2)).*[x_sim z_sim];
    
    log_obj=@(theta) CUGMM_loglik(gmat(tau,theta(1),theta(2))) -10^10*(1-(theta(1)>=beta_bounds(1) && theta(1)<=beta_bounds(2)...
        && theta(2)>=alpha_bounds(1) && theta(2)<=alpha_bounds(2)));
    [theta_store_temp, obj_store]=slicesample_custom(theta_init,chain_length,'logpdf',log_obj,'width',1/sqrt(sim_obs/obs));% 10K obs, width 10, thin 10 looks good for MC convergence.
    theta_store_temp=theta_store_temp';    
    
    beta_temp=theta_init(1);
    alpha_temp=theta_init(2);
    
    gmat_temp=repmat(rho(tau,y_sim-d_sim*beta_temp-x_sim*alpha_temp),1,size(x_sim,2)+size(z_sim,2)).*[x_sim z_sim];
    g_temp=mean(gmat_temp);
    Sigma_temp=cov(gmat_temp);
    trial_log_obj=-0.5*sim_obs*g_temp*pinv(Sigma_temp)*g_temp';
    
    accept_store_temp=NaN(chain_length,1);
    
    Post_mean_store(:,m)=mean(theta_store_temp,2);
    Post_sd_store(:,m)=std(theta_store_temp')';
    
    Max_location=obj_store==max(obj_store)';
    GMM=theta_store_temp(:,Max_location)';
    GMM=GMM(end,:);
    GMM_store(:,m)=GMM;
    
    accept_store(m,1)=mean(accept_store_temp);
end

