close all

tail_trim=0.01;
alpha_lower=quantile(GMM_store_big(1,:,1,1),tail_trim);
alpha_upper=quantile(GMM_store_big(1,:,1,1),1-tail_trim);

beta_lower=quantile(GMM_store_big(2,:,1,1),tail_trim);
beta_upper=quantile(GMM_store_big(2,:,1,1),1-tail_trim);

steps=15;

weak_alpha_thresholds=alpha_lower:(alpha_upper-alpha_lower)/steps:alpha_upper;
weak_beta_thresholds=beta_lower:(beta_upper-beta_lower)/steps:beta_upper;
figure(1)
subplot(2,3,4)
histogram(GMM_store_big(1,:,1,1)',weak_alpha_thresholds)
title('1x Sample','FontSize',16)
xlabel('\beta','FontSize',16)
xlim([alpha_lower alpha_upper])
subplot(2,3,5)
histogram(GMM_store_big(1,:,2,2)',weak_alpha_thresholds)
title('Weak Asymptotics, 100x Sample','FontSize',16)
xlabel('\beta','FontSize',16)
xlim([alpha_lower alpha_upper])
subplot(2,3,6)
histogram(GMM_store_big(1,:,2,1)',steps)
title('Strong Asymptotics, 100x Sample','FontSize',16)
xlabel('\beta','FontSize',16)
subplot(2,3,1)
histogram(GMM_store_big(2,:,1,1)',weak_beta_thresholds)
title('1x Sample','FontSize',16)
xlabel('\alpha','FontSize',16)
xlim([beta_lower beta_upper])
subplot(2,3,2)
histogram(GMM_store_big(2,:,2,2)',weak_beta_thresholds)
title('Weak Asymptotics, 100x Sample','FontSize',16)
xlabel('\alpha','FontSize',16)
xlim([beta_lower beta_upper])
subplot(2,3,3)
histogram(GMM_store_big(2,:,2,1)',steps)
title('Strong Asymptotics, 100x Sample','FontSize',16)
xlabel('\alpha','FontSize',16)